/*****************************************************
Project : Ultrasonic Range Finder
Author  : SMH
Chip type           : ATtiny2313
Clock frequency     : 8.000000 MHz
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 50
*****************************************************/
#include <tiny2313.h>
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>
#include <delay.h>
#define Trigger PORTD.3
#define Out1   PORTD.4
#define Out2   PORTD.5
unsigned int timer_val;
char dip_switch;
char s[]="   ";
bit lcd_show_flag=0;
//------------------------------------------
interrupt [EXT_INT0] void ext_int0_isr(void)
{
timer_val=TCNT1;                             
delay_us(20);
if (PIND.2==0)
        {
        GIMSK=0x00;    // disable INT0
        TCCR1B=0x00;
        lcd_show_flag=1;
        }
}
//------------------------------------------
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
TCNT0=0xF4;
Out1=!Out1;
Out2=!Out1;
}
//------------------------------------------
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{    
TCCR1B=0x00;
lcd_clear();
lcd_putsf("Over range");
}
//------------------------------------------
void lcd_show(unsigned int hex_val);
void main(void)
{
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
PORTA=0x00;
DDRA=0x00;
PORTB=0x00;
DDRB=0x00;
PORTD=0x00;
DDRD=0x78;
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000.000 kHz
TCCR0A=0x00;
TCCR0B=0x00;    //stop timer0
TCNT0=0xF4;
OCR0A=0x00;
OCR0B=0x00;
//---------------------------------------
TCCR1A=0x00;
TCCR1B=0x00;     //stop timer1
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
//----------------------------------------
GIMSK=0x00;     //disable INT0
MCUCR=0x02;
EIFR=0x40;
//----------------------------------------
TIMSK=0x82;
ACSR=0x80;
//----------------------------------------
lcd_init(16);
#asm("sei")
lcd_clear();
lcd_putsf("start");
delay_ms(1000);
Out1=0;
Out2=0;
while (1)
      {
                GIMSK=0x00;    //disable INT0
                TCNT0=0xF4;
                TCNT1=0x0000;
                //---------------------------
                Trigger=0;     
                delay_ms(10);
                TCCR0B=0x02;   //start timer0
                TCCR1B=0x02;   //start timer1
                //---------------------------
                delay_us(100);
                //---------------------------
                TCCR0B=0x00;   //stop timer0
                Out1=0;
                Out2=0; 
                Trigger=1;
                delay_us(150);
                GIMSK=0x40;    // enable INT0
                dip_switch=(PIND&0x03);
                switch (dip_switch) 
                   {
                     case 0:
                     delay_ms(200);
                     break;
                     case 1:
                     delay_ms(500);
                     break;
                     case 2:
                     delay_ms(1000);
                     break;
                     case 3:
                     delay_ms(2000);
                     break;
                   }; 
                //----------------------------   
                if(lcd_show_flag)
                   {
                    lcd_show(timer_val);
                    lcd_show_flag=0;
                   } 
      };
}
//-------------------------------------------
void lcd_show(unsigned int hex_val)
        {  
         unsigned int distance;
         unsigned long int d;
         char i;
         d=hex_val/2;
         d=d*343;
         d=d/10000;
         distance=d;
         for(i=2;i>=0;i--)
                 {
                 s[i]=(distance%10)+0x30;
                 distance=distance/10;     
                 }       
         lcd_clear();
         lcd_putsf("Range> ");
         lcd_puts(s);
         lcd_putsf("cm");         
        }
//--------------------------------------------     
